<?php

class User {
private $Username;
private $rolename;
private $can_login;
private $can_provision;
private $can_deprovision;
private $Tags;

function __construct($mysqli,$Username) {

	 if($Username){
		$this->populate($mysqli,$Username);
	 }
}

public function __toString(){
$t =  $this->Username.":".
       $this->rolename.":".
       $this->can_login.":".
       $this->can_provision.":".
       $this->can_deprovision.":";
  foreach ($this->Tags as $tag){
  	  $t .= $tag.":";
  }
  return $t;
}

function populate($mysqli,$Username){
	 $tag_ar = array();
	 $rolename='';
	 $can_login=False;
	 $can_provision=False;
	 $can_deprovision=False;
	 $uid=0;
	$stmt = $mysqli->prepare("select rolename,can_login, can_provision, can_deprovision from user_roles,users where user_roles.rolename=users.user_role and login=?;");
	$stmt->bind_param("s", $Username);
      	$stmt->bind_result($rolename,$can_login,$can_provision,$can_deprovision);
	$stmt->execute();
	$stmt->fetch();
	#account detail (privs...)
	$this->rolename=$rolename;
	$this->can_login=$can_login;
 	$this->can_provision=$can_provision;
	$this->can_deprovision=$can_deprovision;
	$this->Username = $Username;
	$stmt->close();
	$stmt = $mysqli->prepare("select UID from users,tags_status,tags,users_vs_tags where users_vs_tags.user_login=users.login and users_vs_tags.tag_UID=tags.UID and tags.status=tags_status.status_name and login=?;");
	$stmt->bind_param("s", $Username);
	$stmt->bind_result($uid);
	$stmt->execute();
	$this->Tags=array();
	while($stmt->fetch()){
	 array_push($tag_ar,$uid);
	}
	$stmt->close();
	foreach ($tag_ar as $t){
	array_push($this->Tags,new Tag($mysqli,$t));
	}
}

function getUsername(){return $this->Username;}

function setUsername($mysqli,$Username){
	 $stmt = $mysqli->prepare("update users set login=? where login=?;");
	 $stmt->bind_param("ss", $Username,$this->Username);
	 try {
	     $stmt->execute();
	 }catch(Exception $e){
	     $Username=$this->Username;
         }
	 $this->Username=$Username;
}

function getrolename(){return $this->rolename;}
function setrolename($mysqli,$rolename){$this->rolename=$rolename;}
function getcan_login(){return $this->can_login;}
function getcan_provision(){return $this->can_provision;}
function getcan_deprovision(){return $this->can_deprovision;}
function getTags(){return $this->Tags;}
function setTags($mysqli,$Tags){$this->Tags=$Tags;}



}



?>